package Bot::OuliBase;

use strict;

use base qw (Parse::RecDescent Bot::BasicBot);
use Oulibot;
use Class::MethodMaker get_set => [ qw( context nick )]; 
use Data::Dumper;
$::RD_HINT = 1;

{
    sub mind { return '#oulibot'; }
    sub name { my $self = shift; return $self->nick; }
}

sub new {
    my $class = shift;
    my %args = @_;
    my $self = bless { }, ref $class || $class;
    my $grammar = $self->grammar;
    $self = Parse::RecDescent->new($grammar);
    bless $self, $class;

    #foreach my $method (keys %args) {
#	$self->$method($args{$method}) if $self->can($method);
#    }
#    return $self;
}


sub grammar {
    return q{
	_statement : _help | _ping  
        _help : 'help' { return $self->help }
	_ping : 'ping' { return $self->ping }
    };
}

sub said {
    my ($self, $said) = @_;
    $self->context($said);

    ($said->{event}) = $said->{body} =~ /^(\d\d\d\d)/;
    $said->{body} =~ s/^\d\d\d\d//;

    my $response = $self->try($said->{body});
    if ($response) {
#	warn(Dumper($said->{body}));
	$said->{body} = $said->{event}.' '.$response;
	return $said;
    }
    return undef;
}

sub status {
    my $self = shift;
    my $context = $self->context;
    $context->{body} = $self->status;
    return $context if $self->status;
}

sub talk_to_channel {
    my ($self,$verb) = @_;
    $self->say({channel => $self->mind,
                body => $self->context->{event}.' '.$verb.' '.$self->context->{body}});
}


sub help {
    return 'i am an aspect of OuLiBOT. http://info.oulibot.org/irc.html | oulibot@frot.org | irc://irc.rhizomatic.net/zool';
}

sub ping {
    my $self = shift;
    my $context = $self->context;
    $context->{body} = 'pong!';
    return $context;
}

sub try {
    my ($self,$line) = @_;
    my $response = $self->_statement($line);
 #   warn($response);
    return $response if $response;
    return undef;
}

sub chunk_irc_length {
    my ($self,$text) = @_;
    my @bits = split(' ',$text);
    my $shorter;
    my $n = 0;
    while (length($shorter) > 431) {
	$shorter .= $bits[$n];
	$n++;
    }
    return $shorter;
}

##
1;







