package Bot::Oulibabel;

use strict;
use Oulibot::Babel;
use WWW::Babelfish;
use base qw(Bot::OuliBase);

sub grammar {
    return q{ 
	_statement : _translate
	_translate : 'speak' { return $self->translate(@item[1..$#item]) } 
	           | 'think' { return $self->translate(@item[1..$#item]) } 
    };
}

sub translate {
    my ($self,$text) = @_;

    my $translator = $self->translator; 
    
    my @words = $translator->translate($text);
    if (not @words) {
	@words = $translator->learn_translations($text);
    }
    
    if (scalar(@words) > 0) {
        return 'learn '.join(' ',@words);
    }
    return undef;
}

sub status {
    my $self = shift;
    my $languages = $self->languages;
    return 'speaking '.join(' ',@{$languages});
}
sub translator {
    my $self = shift;
    return $self->{_tr} if $self->{_tr};
    $self->{_tr} = Oulibot::Translator->new;
}

1;

