package Bot::Oulisrch;

use base qw(Bot::OuliBase);
use Oulibot::Searcher;

sub grammar {
    return q{ 
	_statement : _learn | _respond
	_learn : 'learn' /.+/ { return $self->learn(@item[2..$#item]) }
	_respond : 'respond' /.+/ { return $self->learn(@item[2..$#item]) }

    };
}

sub searcher {
    my $self = shift;
    return $self->{searcher} if $self->{searcher};
    $search = Oulibot::Searcher->new(
				     site => 'www.alltheweb.com',
				     search_uri => '/search?l=any&q=SEARCHTERM',
				     parser => 'AllTheWeb'
				     );
    $self->{searcher} = $search;
    return $self->{searcher};
}

sub learn {
    my ($self,$text) = @_;
    warn("learning: $text");
    my $searcher = $self->searcher;
    my $uris = $searcher->search_for_new_uris($text);

    my $response;
    foreach (@{$uris}) {
	$response .= 'read '.$_."\n";
    }
    return $response;
}


1;














