
package Bot::Oulithink;

use strict;
use base qw( Bot::OuliBase );

sub grammar {
    return q{
	_statement : _speak
	_speak : 'speak' /.+/ { return $self->think(@item[2..$#item]) }
    };

}

sub oulibot {
    my $self = shift;
    return $self->{oulibot} if $self->{oulibot};
    my $oulibot = Oulibot->new( table => 'pages' );
    $oulibot->context(10);
    $self->{oulibot} = $oulibot;
}

sub think {
    my ($self,$text) = @_;
    my ($out,$respond);
    if ($text =~ m/^oulibot/) {
	$text =~ s/oulibot.//;
	$respond = 'respond';
    }

    my $thought = $self->contemplate($text);

    my $matching_pages = $self->oulibot->matched;
    if ($matching_pages < 42){
	if ($matching_pages eq 0) {
	    $respond ||= 'learn';
	    $out = $text if $respond eq 'learn';
	}
	else {
	    $respond ||= 'learn';
	    $out = $thought;
	}
    }
    else {
	$respond ||= 'think';
	$out = $thought;
    }
    warn($respond.' '.$out);
    return $respond.' '.$out;
}

sub contemplate {
    my ($self, $thing) = @_;
    my $respond;

    my $oulibot = $self->oulibot;
#    my @sentence = $oulibot->context_match($thing);
    my $aphorism = $oulibot->aphorism($thing);
#    my $aphorism = $sentence[rand @sentence];
    $aphorism =~ s/^ //;
    # chunk for irc length
    if (length($aphorism) > 457) {
	$aphorism = $self->chunk_irc_length($aphorism)
    }
    return $aphorism;
}

1;
