package Oulibot::Parsers::Toledo;

use strict;

use base qw( Oulibot::Parsers::Base );

sub parse_search {
    my $self = shift;
    my $text = shift;
    my @return;

    my @lines = split '\n', $text;
    foreach (@lines) {
        next unless ($_ =~ m/SearchID/) && ($_ =~ m/artikkel/);

        my ($uri, $title) = split '<b>', $_;

        $uri =~ s/<a href="//;
        $uri =~ s/">//;
        $uri =~ s/SearchID=\d+&//;

        $title =~ s|</b></a></FONT><br>||;
        my $result = {title => $title, uri => $uri, desc => undef };
        push @return, $result;
    }
    return \@return;
}

sub parse {
    my $self = shift;
    my $text = shift;
    my @lines = split '\n', $text;
    my $return;
    foreach (@lines) {
        next unless $_ =~ m/bowling green/i; # case insensitive
        my $line = $_;
        $line =~ s/<br>/\n/g;
        $line =~ s/<B>/*/g;
        $line =~ s/<\/B>/*/g;
        $return .= $line;
    }
    return $return;
}

1;



