package Oulibot::Template::Plugin::RAMOS;

use strict;
use base qw(Oulibot::Template::Plugin::Base);

{
    my @keywords = ('Genetic', 'Algorithms', 'Artificial', 'Neoteny', 'Dynamic', 'Mutation Rates', 'Convergence', 'Segmentation', 'Classification', 'Clustering','Swarming','Neural','A-Life','Synthetic','Emergent');
    sub keywords {
        return @keywords;
    }
}

sub title {
    my $self = shift;
    my @keys = @{$self->choose_keys};
    my $title = $keys[0]." ".$keys[1]." in ".$keys[2]." ".$keys[3];
    return $title;
}


sub choose_keys {
    my $self = shift;
    return $self->{choice} if $self->{choice};
    my @keywords = $self->keywords;
    my @choice;
    until (scalar(@choice) eq 4) {
        my $try = @keywords[rand @keywords];
        #warn($try);
        my @seen = grep {/$try/} @choice;
        push @choice, $try if scalar(@seen) eq 0;
    }
    $self->{choice} = \@choice;
}


1;

