package Word::DB;

use strict;
use Bot::RDFDB;

use Class::MethodMaker new_hash_init => 'new', get_set => [ qw( database ) ];

sub rdf {
    my $self = shift;
    return $self->{rdf} if $self->{rdf};
    my $database = $self->database || 'word';
    $self->{rdf} = Bot::RDFDB->new( database => $database, table => 'words'); 
}

sub add {
    my $self = shift;
    my %p = shift;
    my $lang = $p{language};
    my $word = $p{word};
    $word = ucfirst($word);
    $word =~ s/ /_/g;
    $self->rdf->add_triple($self->rdf->namespace("wn:$word"),$self->rdf->namespace('dc:lang'),$lang);
    return $word;
}

sub exists {
    my $self = shift;
    my %p = shift;
    my $lang = $p{language};
    my $word = $p{word};
    $word = ucfirst($word);
    $word =~ s/ /_/g;
    $word = $self->rdf->namespace("wn:$word");
    my @things = $self->rdf->triples( variables => ['x'],
				      queries => [[$word,$self->rdf->namespace("dc:lang"),'?x']]);

    
    foreach (@things) {
	return $word if $_->[0] eq $lang;
    }
    return undef;
}    

1;
