package Word::EN::Wordnet;

use strict;

use Word;

use Class::MethodMaker
  new_hash_init => 'new', get_set => [ qw{word}];


sub over {

    my $self = shift;

    my $w = $self->word;
    my $word;
    if (ref $w eq 'HASH') {
        $word = $w->word;
    }
    else {
        $word = $w;
    }

    open WORD, "/usr/local/wordnet/bin/wn \"$word\" -over |" or die "could not run wn: $!";

    my $seenlist = {};
    my $currentsense;

    while (<WORD>) {
        my $text = $_;

#        print $text;

        if ($text =~ m/Overview/) {
            my @words = split ' ', $text;
            $currentsense = $words[2];
        }
        elsif ($text =~ m/^\d/) {
            my @halves = split '--', $text;
            my @words = split ',', $halves[0];

            foreach my $w (@words) {

                next if $w eq '';
                $w =~ s/[^a-zA-Z|\s]//g;
                $w =~ s/^[\s]//;

#               next if $w eq $word;

                my @seen = grep(/$w/, @{$seenlist->{$currentsense}});

                if (scalar(@seen) eq 0) {
                    push @{$seenlist->{$currentsense}}, $w;
                }
            }
        }
    }
    close WORD;
    $self->{_over} = $seenlist;
    return $self->{_over};
}

1;


