#!/usr/bin/perl

use strict;

use lib qw(./lib);
use Oulibot;
use Oulibot::Grabber;
use Oulibot::Searcher;

my $said = shift || 'semantic web';
my $bot = Oulibot->new();
my $aph = $bot->aphorism($said);

if (not $aph) {
    print "don't know about $said ... \n";
    my $search = Oulibot::Searcher->new(
					site => 'www.alltheweb.com',
					search_uri => '/search?l=any&q=SEARCHTERM',
					parser => 'AllTheWeb'
					);
    my $grab = Oulibot::Grabber->new;

    my $uris = $search->search_for_new_uris($said);
    foreach (@{$uris}) {
	$grab->grab($_);
    }
}
else {
    my @statements = $bot->contextualise($said);
    print join("\n",@statements)."\n";
	
}
